/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.system.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="SYSTEM_LOG.All",
     query="DELETE FROM SystemLog o WHERE o.mandant=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="SYSTEM_LOG.CountStatusArt",
     query="SELECT COUNT(o) FROM SystemLog o WHERE o.mandant=?1 AND o.status = ?2 AND o.logNachrichtArt=?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="SYSTEM_LOG.CountStatus",
     query="SELECT COUNT(o) FROM SystemLog o WHERE o.mandant=?1 AND o.status = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="SYSTEM_LOG.Status",
     query="UPDATE SystemLog o SET o.status = ?2 WHERE o.mandant=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "SYSTEM_LOG")
// @javax.persistence.IdClass(SystemLogPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class SystemLog
implements SystemLogBase
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public SystemLog() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public SystemLog(SystemLog original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "system_log_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "SystemLog")
    @javax.persistence.TableGenerator(name = "SystemLog", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "SystemLog", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient SystemLogPK pkCache;

  @Override
  public SystemLogPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new SystemLogPK(getId());
    }

    return pkCache;
  }

  public static <E extends SystemLog> java.util.Map<SystemLogPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<SystemLogPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends SystemLog> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedLogNachricht = false;
          hasChangedLogNachrichtArt = false;
          hasChangedQuelle = false;
          hasChangedStatus = false;
          hasChangedZeitpunkt = false;
  
      hasChangedMandant = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
      @javax.persistence.Column(name = "LOG_NACHRICHT", nullable = SystemLogConstants.LOG_NACHRICHT_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String logNachricht =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLogNachricht = false;

  public boolean hasChangedLogNachricht(){
    return hasChangedLogNachricht;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertLogNachricht = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenLogNachricht;
  
  /**
   * 
   *
   * getter for SYSTEM_LOG.LOG_NACHRICHT
   *
   * (LAZY LOADING)
   */
    @Override   public  java.lang.String getLogNachricht() {
        return logNachricht;
      }

  /**
   * 
   *
   * setter for SYSTEM_LOG.LOG_NACHRICHT
   *
   * @param logNachricht
   */
  @Override   public void setLogNachricht( java.lang.String logNachricht) {

       resetTkCache();
                  java.lang.String logNachrichtInternal = org.apache.commons.lang3.StringUtils.trimToNull(logNachricht);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.logNachricht
      , logNachrichtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLogNachricht |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("logNachricht");
      }


             if (!isSeitLadenVeraendertLogNachricht) {
          isSeitLadenVeraendertLogNachricht = thisAttributChanged;
         if (isSeitLadenVeraendertLogNachricht){
           wertNachLadenLogNachricht=this.logNachricht;
         }
       }
      

       this.logNachricht = logNachrichtInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "LOG_NACHRICHT_ART", nullable = SystemLogConstants.LOG_NACHRICHT_ART_NULLABLE)
    
  protected de.ivu.elect.business.system.entity.LogNachrichtArt logNachrichtArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLogNachrichtArt = false;

  public boolean hasChangedLogNachrichtArt(){
    return hasChangedLogNachrichtArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertLogNachrichtArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.system.entity.LogNachrichtArt wertNachLadenLogNachrichtArt;
  
  /**
   * 
   *
   * getter for SYSTEM_LOG.LOG_NACHRICHT_ART
   */
    @Override   public  de.ivu.elect.business.system.entity.LogNachrichtArt getLogNachrichtArt() {
        return logNachrichtArt;
      }

  /**
   * 
   *
   * setter for SYSTEM_LOG.LOG_NACHRICHT_ART
   *
   * @param logNachrichtArt
   */
  @Override   public void setLogNachrichtArt( de.ivu.elect.business.system.entity.LogNachrichtArt logNachrichtArt) {

       resetTkCache();
                  de.ivu.elect.business.system.entity.LogNachrichtArt logNachrichtArtInternal = logNachrichtArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.logNachrichtArt
      , logNachrichtArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLogNachrichtArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("logNachrichtArt");
      }


             if (!isSeitLadenVeraendertLogNachrichtArt) {
          isSeitLadenVeraendertLogNachrichtArt = thisAttributChanged;
         if (isSeitLadenVeraendertLogNachrichtArt){
           wertNachLadenLogNachrichtArt=this.logNachrichtArt;
         }
       }
      

       this.logNachrichtArt = logNachrichtArtInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "QUELLE", nullable = SystemLogConstants.QUELLE_NULLABLE)
    
  protected de.ivu.elect.business.system.entity.SystemLogQuelle quelle =  null;

  @javax.persistence.Transient
  protected boolean hasChangedQuelle = false;

  public boolean hasChangedQuelle(){
    return hasChangedQuelle;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertQuelle = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.system.entity.SystemLogQuelle wertNachLadenQuelle;
  
  /**
   * 
   *
   * getter for SYSTEM_LOG.QUELLE
   */
    @Override   public  de.ivu.elect.business.system.entity.SystemLogQuelle getQuelle() {
        return quelle;
      }

  /**
   * 
   *
   * setter for SYSTEM_LOG.QUELLE
   *
   * @param quelle
   */
  @Override   public void setQuelle( de.ivu.elect.business.system.entity.SystemLogQuelle quelle) {

       resetTkCache();
                  de.ivu.elect.business.system.entity.SystemLogQuelle quelleInternal = quelle;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.quelle
      , quelleInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedQuelle |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("quelle");
      }


             if (!isSeitLadenVeraendertQuelle) {
          isSeitLadenVeraendertQuelle = thisAttributChanged;
         if (isSeitLadenVeraendertQuelle){
           wertNachLadenQuelle=this.quelle;
         }
       }
      

       this.quelle = quelleInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = SystemLogConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.system.entity.SystemLogStatus status =  de.ivu.elect.business.system.entity.SystemLogStatus.ZU_PRUEFEN;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.system.entity.SystemLogStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for SYSTEM_LOG.STATUS
   */
    @Override   public  de.ivu.elect.business.system.entity.SystemLogStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for SYSTEM_LOG.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.system.entity.SystemLogStatus status) {

       resetTkCache();
                  de.ivu.elect.business.system.entity.SystemLogStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ZEITPUNKT", nullable = SystemLogConstants.ZEITPUNKT_NULLABLE, precision=SystemLogConstants.ZEITPUNKT_PRECISION)
    
  protected java.util.Date zeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZeitpunkt = false;

  public boolean hasChangedZeitpunkt(){
    return hasChangedZeitpunkt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertZeitpunkt = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenZeitpunkt;
  
  /**
   * 
   *
   * getter for SYSTEM_LOG.ZEITPUNKT
   */
    @Override   public  java.util.Date getZeitpunkt() {
              if (zeitpunkt == null){
            return null;
          } else {
                          return zeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for SYSTEM_LOG.ZEITPUNKT
   *
   * @param zeitpunkt
   */
  @Override   public void setZeitpunkt( java.util.Date zeitpunkt) {

       resetTkCache();
                  java.util.Date zeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(zeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zeitpunkt
      , zeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zeitpunkt");
      }


             if (!isSeitLadenVeraendertZeitpunkt) {
          isSeitLadenVeraendertZeitpunkt = thisAttributChanged;
         if (isSeitLadenVeraendertZeitpunkt){
           wertNachLadenZeitpunkt=this.zeitpunkt;
         }
       }
      

       this.zeitpunkt = zeitpunktInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Mandant
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "MANDANT_ID", referencedColumnName="MANDANT_ID"))
  protected de.ivu.elect.business.mandant.entity.Mandant mandant;

  /**
   * 
   */
  @Override
  public void setMandant( de.ivu.elect.business.mandant.entity.Mandant mandant){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mandant
    , mandant);

    attributeChanged |= thisAttributChanged;

    hasChangedMandant |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("mandant");
    }

    this.mandant = mandant;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.mandant.entity.Mandant getMandant(){
    return this.mandant;
  }

  @javax.persistence.Transient
  protected boolean hasChangedMandant = false;

  public boolean hasChangedMandant(){
    return hasChangedMandant;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("SystemLog:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(SystemLog other){
                             other.logNachricht = this.logNachricht;
                                other.logNachrichtArt = this.logNachrichtArt;
                                other.quelle = this.quelle;
                                other.status = this.status;
                                other.zeitpunkt = this.zeitpunkt;
           
  other.setMandant(this.getMandant());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(SystemLog.class)){
        copyEntityAttributesUsingSetter((SystemLog) other.castTo(SystemLog.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von SystemLog: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(SystemLog other){
               other.setLogNachricht(this.logNachricht);
                  other.setLogNachrichtArt(this.logNachrichtArt);
                  other.setQuelle(this.quelle);
                  other.setStatus(this.status);
                  other.setZeitpunkt(this.zeitpunkt);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(SystemLog other){
                       if (hasChangedLogNachricht) {
        other.setLogNachricht(this.logNachricht);
      }
                             if (hasChangedLogNachrichtArt) {
        other.setLogNachrichtArt(this.logNachrichtArt);
      }
                             if (hasChangedQuelle) {
        other.setQuelle(this.quelle);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedZeitpunkt) {
        other.setZeitpunkt(this.zeitpunkt);
      }
             }





    @javax.persistence.Transient
    private transient SystemLogTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public SystemLogTK getSystemLogTK(){
    if (tkCache==null) {
    tkCache = new SystemLogTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getSystemLogTK();
    }

  @Override
  public SystemLogUK getUk(){
    return getSystemLogUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return SystemLog.class;
  }

public SystemLogUK getSystemLogUK(){

   return  new SystemLogUK(



  );
}

  @javax.persistence.Transient
  private transient SystemLogProperties properties;

  public SystemLogProperties getProperties(){
    if (properties == null) {
      properties = new SystemLogProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public SystemLogProperties getSystemLogProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return SystemLogConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(SystemLogConstants.MESSAGE_KEY_LOG_NACHRICHT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(SystemLogConstants.MESSAGE_KEY_LOG_NACHRICHT_EINZAHL);

        logNachricht =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(SystemLogConstants.MESSAGE_KEY_LOG_NACHRICHT_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(SystemLogConstants.MESSAGE_KEY_LOG_NACHRICHT_ART_EINZAHL);

        logNachrichtArt =
     (de.ivu.elect.business.system.entity.LogNachrichtArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(SystemLogConstants.MESSAGE_KEY_QUELLE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(SystemLogConstants.MESSAGE_KEY_QUELLE_EINZAHL);

        quelle =
     (de.ivu.elect.business.system.entity.SystemLogQuelle) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(SystemLogConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(SystemLogConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.system.entity.SystemLogStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(SystemLogConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(SystemLogConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL);

        zeitpunkt =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertLogNachricht) {
      result.put(SystemLogConstants.MESSAGE_KEY_LOG_NACHRICHT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.LOB
                , wertNachLadenLogNachricht , logNachricht));
    }
                            if (isSeitLadenVeraendertLogNachrichtArt) {
      result.put(SystemLogConstants.MESSAGE_KEY_LOG_NACHRICHT_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenLogNachrichtArt , logNachrichtArt));
    }
                            if (isSeitLadenVeraendertQuelle) {
      result.put(SystemLogConstants.MESSAGE_KEY_QUELLE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenQuelle , quelle));
    }
                            if (isSeitLadenVeraendertStatus) {
      result.put(SystemLogConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                            if (isSeitLadenVeraendertZeitpunkt) {
      result.put(SystemLogConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenZeitpunkt , zeitpunkt));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertLogNachricht = false;
      wertNachLadenLogNachricht = null;
                          isSeitLadenVeraendertLogNachrichtArt = false;
      wertNachLadenLogNachrichtArt = null;
                          isSeitLadenVeraendertQuelle = false;
      wertNachLadenQuelle = null;
                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                          isSeitLadenVeraendertZeitpunkt = false;
      wertNachLadenZeitpunkt = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "SYSTEM_LOG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "SystemLog";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(logNachricht, this, SystemLogConstants.MESSAGE_KEY_LOG_NACHRICHT_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(SystemLogConstants.LOG_NACHRICHT_MAX_LENGTH , 1 ,  logNachricht, this, SystemLogConstants.MESSAGE_KEY_LOG_NACHRICHT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(logNachrichtArt, this, SystemLogConstants.MESSAGE_KEY_LOG_NACHRICHT_ART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(quelle, this, SystemLogConstants.MESSAGE_KEY_QUELLE_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, SystemLogConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(zeitpunkt, this, SystemLogConstants.MESSAGE_KEY_ZEITPUNKT_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
